%define _buildid .5

%global py26nvr python26-urllib3-%{version}-%{release}
%global py26builddir %{_builddir}/%{py26nvr}
%global py26doc ../%{py26nvr}

%global py27nvr python27-urllib3-%{version}-%{release}
%global py27builddir %{_builddir}/%{py27nvr}
%global py27doc ../%{py27nvr}

%bcond_without tests # with

%global upstream_name urllib3

Name: python-urllib3
Version: 1.8.2
Release: 1%{?_buildid}%{?dist}
Summary: Python HTTP library with thread-safe connection pooling and file post
Group: System Environment/Libraries
License: MIT
URL: http://urllib3.readthedocs.org/
Source0: http://pypi.python.org/packages/source/u/%{upstream_name}/%{upstream_name}-%{version}.tar.gz
# make all imports of things in packages try system copies first
Patch0: python-urllib3-unbundle.patch
# Remove logging-clear-handlers from setup.cfg because it's not available in RHEL6's nose
Patch100: python-urllib3-old-nose-compat.patch
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python26
BuildRequires: python27

%description
Python HTTP module with connection pooling and file POST abilities.

%package -n python26-urllib3
Summary: Python HTTP library with thread-safe connection pooling and file post
# Needed on Amazon Linux until we are able to upgrade python-nose
BuildRequires: python26-ordereddict
BuildRequires: python26-devel
# For unit tests
BuildRequires: python26-nose
BuildRequires: python26-mock
BuildRequires: python26-six
BuildRequires: python26-tornado
BuildRequires: python26-backports-ssl_match_hostname
Requires: ca-certificates
Requires: python26-six
Requires: python26-ordereddict
Requires: python26-backports-ssl_match_hostname
Provides: python-urllib3 = %{version}-%{release}
Obsoletes: python-%{upstream_name} <= 1.8.2-1.2.amzn1

%description -n python26-urllib3
Python HTTP module with connection pooling and file POST abilities.

This package is meant to be used with Python 2.6.

%package -n python27-urllib3
Summary: Python HTTP library with thread-safe connection pooling and file post
BuildRequires: python27-devel
# For unit tests
BuildRequires: python27-nose
BuildRequires: python27-mock
BuildRequires: python27-six
BuildRequires: python27-tornado
BuildRequires: python27-backports-ssl_match_hostname
Requires: ca-certificates
Requires: python27-six
Requires: python27-backports-ssl_match_hostname

%description -n python27-urllib3
Python HTTP module with connection pooling and file POST abilities.

This package is meant to be used with Python 2.7.

%prep
%setup -q -n %{upstream_name}-%{version}
rm -r %{upstream_name}/packages/

%patch0 -p1
%if 0%{?rhel} && 0%{?rhel} <= 6 || 0%{?amzn}
%patch100 -p1
%endif

%build
rm -rf %{py26builddir}
mkdir -p %{py26builddir}
cp -a * %{py26builddir}
pushd %{py26builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python26} setup.py build 
popd

rm -rf %{py27builddir}
mkdir -p %{py27builddir}
cp -a * %{py27builddir}
pushd %{py27builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python27} setup.py build 
popd

%install
rm -rf %{buildroot}

pushd %{py26builddir}
%{__python26} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd

pushd %{py27builddir}
%{__python27} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
# dummyserver is part of the unittest framework
rm -rf %{buildroot}%{python26_sitelib}/dummyserver
# dummyserver is part of the unittest framework
rm -rf %{buildroot}%{python27_sitelib}/dummyserver

%check
%if %{with tests}
pushd %{py26builddir}
nosetests-2.6
popd
pushd %{py27builddir}
nosetests-2.7
popd
%endif

%clean
rm -rf %{buildroot}
rm -rf %{py26builddir}
rm -rf %{py27builddir}

%files -n python26-urllib3
%doc CHANGES.rst LICENSE.txt README.rst CONTRIBUTORS.txt
%{python26_sitelib}/*

%files -n python27-urllib3
%doc CHANGES.rst LICENSE.txt README.rst CONTRIBUTORS.txt
%{python27_sitelib}/*

%changelog
* Thu Feb 5 2015 Tom Kirchner <tjk@amazon.com>
- Build for multiple python versions

* Fri Sep 12 2014 Rodrigo Novo <rodarvus@amazon.com>
- Clean-up (i.e., explicitly describe) python3 installation path
- Fixed Fedora-specific %with clause to a %bcond; cleaned-up spec file
- import source package GOBI/python-urllib3-1.8.2-1.fc20

* Mon Apr 21 2014 Arun S A G <sagarun@gmail.com> - 1.8.2-1
- Update to latest upstream version

* Mon Oct 28 2013 Ralph Bean <rbean@redhat.com> - 1.7.1-2
- Update patch to find ca_certs in the correct location.

* Mon Oct 28 2013 Andrew Jorgensen <ajorgens@amazon.com>
- import source package F19/python-urllib3-1.7-4.fc19

* Wed Sep 25 2013 Ralph Bean <rbean@redhat.com> - 1.7.1-1
- Latest upstream with support for a new timeout class and py3.4.

* Fri Aug 30 2013 Lee Trager <ltrager@amazon.com>
- Require ordereddict on AL as well
- import source package F19/python-urllib3-1.7-3.fc19

* Wed Aug 28 2013 Ralph Bean <rbean@redhat.com> - 1.7-3
- Bump release again, just to push an unpaired update.

* Mon Aug 26 2013 Ralph Bean <rbean@redhat.com> - 1.7-2
- Bump release to pair an update with python-requests.

* Thu Aug 22 2013 Ralph Bean <rbean@redhat.com> - 1.7-1
- Update to latest upstream.
- Removed the accept-header proxy patch which is included in upstream now.
- Removed py2.6 compat patch which is included in upstream now.

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Jun 11 2013 Toshio Kuratomi <toshio@fedoraproject.org> - 1.5-6
- Fix Requires of python-ordereddict to only apply to RHEL

* Tue May 7 2013 Lee Trager <ltrager@amazon.com>
- Apply compat patches on AL as well

* Mon Mar 25 2013 Cristian Gafton <gafton@amazon.com>
- import source package EPEL6/python-urllib3-1.5-5.el6
- setup complete for package python-urllib3

* Fri Mar  1 2013 Toshio Kuratomi <toshio@fedoraproject.org> - 1.5-5
- Unbundling finished!

* Fri Mar 01 2013 Ralph Bean <rbean@redhat.com> - 1.5-4
- Upstream patch to fix Accept header when behind a proxy.
- Reorganize patch numbers to more clearly distinguish them.

* Wed Feb 27 2013 Ralph Bean <rbean@redhat.com> - 1.5-3
- Renamed patches to python-urllib3-*
- Fixed ssl check patch to use the correct cert path for Fedora.
- Included dependency on ca-certificates
- Cosmetic indentation changes to the .spec file.

* Tue Feb  5 2013 Toshio Kuratomi <toshio@fedoraproject.org> - 1.5-2
- python3-tornado BR and run all unittests on python3

* Mon Feb 04 2013 Toshio Kuratomi <toshio@fedoraproject.org> 1.5-1
- Initial fedora build.
